// cCzolg.cpp: implementation of the cCzolg class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ble.h"
#include "cCzolg.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//#include <windows.h>		// Header File For Windows

#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library

#include "cPocisk.h"
#include "cWiatr.h"
#include "cTeren.h"
#include <math.h>

#define PI 3.141
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

float kolory[8][3]={{1.0, 0.0, 0.0}, {0.0, 0.0, 1.0}, {1.0, 1.0, 0.0},
					{0.0, 1.0, 0.0}, {1.0, 0.0, 1.0}, {0.0, 1.0, 1.0},
					{1.0, 0.5, 0.0}, {0.35, 0.35, 1.0}};

cCzolg::cCzolg()
{
	//center[3];
	//color;
	this->reset();
}

cCzolg::~cCzolg()
{

}

int cCzolg::zmienPionowy(int delPion)
{
	this->pionKat=(((this->pionKat)+delPion)%360);
	if (this->pionKat >= 90) this->pionKat=90;
	if (this->pionKat <= 0) this->pionKat=0; 
	return 1;
}


int cCzolg::zmienPoziomy(int delPoz)
{
	this->pozKat=(((this->pozKat)+delPoz)%360);
	if (this->pozKat < 0) this->pozKat=360+this->pozKat;
	return 1;
}


int cCzolg::nadajNumer(int num)
{
	this->nr=num;
	return 1;
}


int cCzolg::ustaw(float pozX, float pozY, float pozZ, float r, float g, float b)
{
	this->pozycja[0]=pozX;
	this->pozycja[1]=pozY;
	this->pozycja[2]=pozZ;
	this->kolor[0]=kolory[this->nr][0];
	this->kolor[1]=kolory[this->nr][1];
	this->kolor[2]=kolory[this->nr][2];
	return 1;
}

int cCzolg::rysuj(cWiatr &Wiatr, cTeren &Teren)
{

if (this->zyje)
{
GLfloat MAmbient[]= { this->kolor[0]/2, this->kolor[1]/2, this->kolor[2]/2, 1.0f }; 
GLfloat MDiffuse[4]={this->kolor[0], this->kolor[1], this->kolor[2], 1.0f };
if (this->aktywny==1) 
{
MDiffuse[0]=1.0f;
MDiffuse[1]=1.0f;
MDiffuse[2]=1.0f;
MDiffuse[3]=1.0f;
};

//GLfloat MSpecular[]= { 1.0f, 1.0f, 1.0f, 1.0f }; 

	glTranslatef(this->pozycja[0], this->pozycja[1], (this->pozycja[2]));
	//glColor3f(this->kolor[0], this->kolor[1], this->kolor[2]);
	glMaterialfv(GL_FRONT, GL_AMBIENT, MAmbient);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, MDiffuse);
	//glMaterialfv(GL_FRONT, GL_SPECULAR, MSpecular);


	glBegin(GL_QUADS); 
	glNormal3f(0.0,-1.0,0.0); 
	glVertex3f(-3, 0, -3);
	glVertex3f(3, 0, -3);
	glVertex3f(3, 0, 3);
	glVertex3f(-3, 0, 3);

	glNormal3f(0.0,1.0,0.0); 
	glVertex3f(-3, 2, -3);
	glVertex3f(3, 2, -3);
	glVertex3f(3, 2, 3);
	glVertex3f(-3, 2, 3);

	glNormal3f(-1.0,0.0,0.0); 
	glVertex3f(-3, 2, -3);
	glVertex3f(-3, 2, 3);
	glVertex3f(-3, 0, 3);
	glVertex3f(-3, 0, -3);

	glNormal3f(1.0,0.0,0.0); 
	glVertex3f(3, 2, -3);
	glVertex3f(3, 2, 3);
	glVertex3f(3, 0, 3);
	glVertex3f(3, 0, -3);

	glNormal3f(0.0,0.0,-1.0); 
	glVertex3f(-3, 2, -3);
	glVertex3f(3, 2, -3);
	glVertex3f(3, 0, -3);
	glVertex3f(-3, 0, -3);

	glNormal3f(0.0,0.0,1.0); 
	glVertex3f(-3, 2, 3);
	glVertex3f(3, 2, 3);
	glVertex3f(3, 0, 3);
	glVertex3f(-3, 0, 3);

	glEnd();
	glTranslatef(0, 3, 0);
	GLUquadricObj *quadratic;
	quadratic=gluNewQuadric(); 
    gluQuadricNormals(quadratic, GLU_SMOOTH); // z generowaniem normalnych

	GLUquadricObj *lufa;
	lufa=gluNewQuadric(); 
	gluQuadricNormals(lufa, GLU_SMOOTH); // z generowaniem normalnych

    gluSphere(quadratic,2.0f,32,32);//narysowanie kuli
	
	glRotatef((float)(this->pozKat), 0, 1, 0);
	glRotatef((float)(-(this->pionKat)), 1, 0, 0);

	gluCylinder(lufa, 0.5, 0.5, 5, 32, 32); 

	glRotatef((float)(this->pionKat), 1, 0, 0);
	glRotatef((float)(-(this->pozKat)), 0, 1, 0);

	glTranslatef(0, -3, 0);
	glTranslatef(-(this->pozycja[0]), -(this->pozycja[1]), -(this->pozycja[2]));
	if (this->animacja==1) 
	{
		
		float SilaX, SilaY, SilaZ;
		float WiatrX, WiatrZ;
		float tmpX, tmpY, tmpZ;
		SilaX=(float)((this->tmpSila)*sin((this->tmpPozKat)*PI/180)*cos((this->pionKat)*PI/180));
		SilaZ=(float)((this->tmpSila)*cos((this->tmpPozKat)*PI/180)*cos((this->pionKat)*PI/180));
		WiatrX=(float)(((Wiatr.Sila)*sin((Wiatr.Kat)*PI/180))/100);
		WiatrZ=(float)(((Wiatr.Sila)*cos((Wiatr.Kat)*PI/180))/100);
		tmpX=(SilaX+WiatrX)/40; //bo maxSila to 100
		tmpZ=(SilaZ+WiatrZ)/40;
		//this->tmpSila=sqrt((SilaX+WiatrX)*(SilaX+WiatrX)+(SilaZ+WiatrZ)*(SilaZ+WiatrZ));
		this->czas++;
		//this->tmpPozKat=(int)(atan((SilaZ+WiatrZ)/(SilaX+WiatrX))*(double)180.0/PI);
		SilaY=(float)((this->Sila)*sin((this->pionKat)*PI/180));
		tmpY=(float)(((SilaY*czas)-(2.0*czas*czas/2))/40);
		//this->tmpSilaPion=this->tmpSilaPion-(9.8/10);
		//tmpY=this->tmpSilaPion;


		int rezultat=this->pocisk.sprawdz(tmpX, tmpY, tmpZ, Teren);

		if (rezultat==2) // w co trafil
		{
			this->animacja=0;
			return 2;
			//this->strzelil=0;
			//MessageBox(hWnd, "Bum !", "Info", MB_OK|MB_ICONSTOP);
		};
		if (rezultat==0)
		{
			this->animacja=0;
			return 0;
		};
		//this->pocisk.rysuj(0, 0, 0);
		
		//if (this->czas>20) { this->animacja=0; this->strzelil=0; };
/*
		if (((tmpY+pocisk.pY)-(Teren.wysokosc((int)pocisk.pX, (int)pocisk.pZ)))<0.5)
		{ 
			this->animacja=0;
			this->strzelil=0;
			pocisk.wybuch(Teren);
			MessageBox(hWnd, "Bum !", "Info", MB_OK|MB_ICONSTOP);
		};
*/
  };
}
else
{
	glTranslatef(this->pozycja[0], this->pozycja[1], (this->pozycja[2]));
GLfloat MAmbient[]= { this->kolor[0]/2, this->kolor[1]/2, this->kolor[2]/2, 1.0f }; 
GLfloat MDiffuse[4]={this->kolor[0], this->kolor[1], this->kolor[2], 1.0f };
	glMaterialfv(GL_FRONT, GL_AMBIENT, MAmbient);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, MDiffuse);


	glBegin(GL_QUADS); 
	glNormal3f(0.0,-1.0,0.0); 
	glVertex3f(-1, 0, -1);
	glVertex3f(-1, 0, 1);
	glVertex3f(1, 0, 1);
	glVertex3f(1, 0, -1);

	glNormal3f(0.0,1.0,0.0); 
	glVertex3f(-1, 7, -1);
	glVertex3f(-1, 7, 1);
	glVertex3f(1, 7, 1);
	glVertex3f(1, 7, -1);

	glNormal3f(-1.0,0.0,0.0); 
	glVertex3f(-1, 7, 1);
	glVertex3f(-1, 7, -1);
	glVertex3f(-1, 0, -1);
	glVertex3f(-1, 0, 1);

	glNormal3f(1.0,0.0,0.0); 
	glVertex3f(1, 7, 1);
	glVertex3f(1, 7, -1);
	glVertex3f(1, 0, -1);
	glVertex3f(1, 0, 1);

	glNormal3f(0.0,0.0,-1.0); 
	glVertex3f(1, 7, -1);
	glVertex3f(-1, 7, -1);
	glVertex3f(-1, 0, -1);
	glVertex3f(1, 0, -1);

	glNormal3f(0.0,0.0,1.0); 
	glVertex3f(1, 7, 1);
	glVertex3f(-1, 7, 1);
	glVertex3f(-1, 0, 1);
	glVertex3f(1, 0, 1);

	// pozioma belka

	glNormal3f(0.0,-1.0,0.0); 
	glVertex3f(-3, 3, -1);
	glVertex3f(-3, 3, 1);
	glVertex3f(3, 3, 1);
	glVertex3f(3, 3, -1);

	glNormal3f(0.0,1.0,0.0); 
	glVertex3f(-3, 5, -1);
	glVertex3f(-3, 5, 1);
	glVertex3f(3, 5, 1);
	glVertex3f(3, 5, -1);

	glNormal3f(-1.0,0.0,0.0); 
	glVertex3f(-3, 5, 1);
	glVertex3f(-3, 5, -1);
	glVertex3f(-3, 3, -1);
	glVertex3f(-3, 3, 1);

	glNormal3f(1.0,0.0,0.0); 
	glVertex3f(3, 5, 1);
	glVertex3f(3, 5, -1);
	glVertex3f(3, 3, -1);
	glVertex3f(3, 3, 1);

	glNormal3f(0.0,0.0,-1.0); 
	glVertex3f(3, 5, -1);
	glVertex3f(-3, 5, -1);
	glVertex3f(-3, 3, -1);
	glVertex3f(3, 3, -1);

	glNormal3f(0.0,0.0,1.0); 
	glVertex3f(3, 5, 1);
	glVertex3f(-3, 5, 1);
	glVertex3f(-3, 3, 1);
	glVertex3f(3, 3, 1);

	glEnd();




	glTranslatef(-(this->pozycja[0]), -(this->pozycja[1]), -(this->pozycja[2]));
};
	return 1;
}

int cCzolg::strzal(int jaka)
{
	if (animacja==0) 
	{
		this->aktywnaBron=jaka;
		if (this->aktywnaBron>0) this->bron[this->aktywnaBron]-=1;
		this->tmpPozKat=(float)(this->pozKat);
		this->tmpSila=(float)(this->Sila);
		this->tmpSilaPion=(float)((this->Sila)*sin((this->pionKat)*PI/180));
		this->pocisk.inicjuj(this->aktywnaBron, this->pozycja[0]+((float)5*sin((float)this->pozKat*PI/180)*cos((float)this->pionKat*PI/180)), this->pozycja[1]+3+((float)5*sin((float)this->pionKat*PI/180)), this->pozycja[2]+((float)5*cos((float)this->pozKat*PI/180)*cos((float)this->pionKat*PI/180)));
		this->pocisk.rysuj(0, 0, 0);
		this->animacja=1;
		this->czas=0;
		this->strzelil=1;
		return 1;
	};
//	else
//	{
//		animacja=0;
//		return 1;
//	};
	return 0;
}

int cCzolg::czyStrzela()
{
	return this->animacja;
}


int cCzolg::aktywuj()
{
	this->aktywny=1;
	this->strzelil=0;
	return 1;
}

int cCzolg::deaktywuj()
{
	this->aktywny=0;
	return 1;
}

int cCzolg::podajFundusze()
{
	return this->fundusze;
}

int cCzolg::ustawFundusze(int Ile)
{
	this->fundusze=Ile;
	return 1;
}

int cCzolg::zmienSile(int wartosc)
{
this->Sila=this->Sila+wartosc;
if (this->Sila < 0) this->Sila=0;
if (this->Sila > 100) this->Sila=100;
return 1;
}

int cCzolg::podajilebroni()
{
return this->bron[this->aktywnaBron];
}

int cCzolg::zmienBron(int jaka)
{
this->aktywnaBron=jaka;
return 1;
}

int cCzolg::UstawY(float wart)
{
	 pozycja[1]=wart;
	 return 0;
}

int cCzolg::podajX()
{
	return (int)pozycja[0];
}

int cCzolg::podajZ()
{
	return (int)pozycja[2];
}

int cCzolg::jakaBron()
{
	return aktywnaBron;
}

int cCzolg::zmianaEnergii(int dEn)
{
	this->energia+=dEn;
	if (this->energia<0) { this->zyje=0; this->energia=0; return 0; };
	return 1;
}

int cCzolg::czyZyje()
{
	return this->zyje;
}

void cCzolg::dodajPunkty(int ile)
{
	this->score+=ile;
}

void cCzolg::dodajPieniadze(int ile)
{
	this->fundusze+=ile;
}

int cCzolg::ozyw()
{
	this->energia=100;
	this->zyje=1;
	return 1;
}

void cCzolg::reset()
{
	wygral=0;
	zyje=1;
	energia=100;
	pionKat=0;
	pozKat=0;
	score=0;
	Sila=50;
	nr=0;
	animacja=0; // nie animujemy (w tej chwili) pocisku
	aktywnaBron=0;
	strzelil=0;
	aktywny=0;
	fundusze=0;
	bron[0]=999;
	bron[1]=0;
	bron[2]=0;
	bron[3]=0;
}
