// cPocisk.cpp: implementation of the cPocisk class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ble.h"
#include "cPocisk.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library

#include "cTeren.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

cPocisk::cPocisk()
{

	this->moc[0]=10;
}

cPocisk::~cPocisk()
{

}

int cPocisk::rysuj(float x, float y, float z)
{
	GLfloat MAmbient[]= { 0.0, 0.0, 0.0, 1.0f }; 
	GLfloat MDiffuse[]={ 0.0, 0.0, 0.0, 1.0f };
	GLUquadricObj *kulka;
	kulka=gluNewQuadric(); 
	float promien;
	gluQuadricNormals(kulka, GLU_SMOOTH); // z generowaniem normalnych
	this->pX+=x;
	//this->pY=y;
	this->pZ+=z;
	glTranslatef( this->pX, this->pY+y, this->pZ);
	//glColor3f(this->kolor[0], this->kolor[1], this->kolor[2]);
	//glMaterialfv(GL_FRONT, GL_SPECULAR, MSpecular);

	
	switch (this->rodzaj)
	{
	case 0: MAmbient[0]=0.2; MAmbient[1]=0.2; MAmbient[2]=0.2;
			MDiffuse[0]=0.8; MDiffuse[1]=0.8; MDiffuse[2]=0.8;
			promien=1;
			break;
	case 1: MAmbient[2]=0.2;
			MDiffuse[2]=0.8;
			promien=1;
			/*GLfloat MAmbient[]= { 0.0, 0.0, 0.2, 1.0f }; 
			GLfloat MDiffuse[]={ 0.0, 0.0, 0.8, 1.0f };
			glMaterialfv(GL_FRONT, GL_AMBIENT, MAmbient);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, MDiffuse);
			GLUquadricObj *kulka;
			kulka=gluNewQuadric(); 
			gluQuadricNormals(kulka, GLU_SMOOTH); // z generowaniem normalnych
			gluSphere(kulka,1.0f,10,10);//narysowanie kuli
			*/
			break;
	case 2: MAmbient[1]=0.2;
			MDiffuse[1]=0.8;
			promien=1;
			break;
	case 3: MAmbient[0]=0.2;
			MDiffuse[0]=0.8;
			promien=1;
			break;
	default: break;
	};
	glMaterialfv(GL_FRONT, GL_AMBIENT, MAmbient);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, MDiffuse);
	gluSphere(kulka,promien,10,10);//narysowanie kuli
	glTranslatef( -(this->pX), -(this->pY+y), -(this->pZ));

	return 1;
}

int cPocisk::inicjuj(int rodzaj, float x, float y, float z)
{
	this->rodzaj=rodzaj;
	this->pX=x;
	this->pY=y;
	this->pZ=z;
	return 1;
}


int cPocisk::wybuch(cTeren &gdzie)
{
    GLfloat MAmbient[]= { 0.2, 0.2, 0, 1.0f }; 
	GLfloat MDiffuse[]={ 0.8, 0.8, 0, 1.0f };
	float tmpWys=gdzie.wysokosc((int)this->pX, (int)this->pZ);
	glTranslatef( (int)this->pX, tmpWys, (int)this->pZ);
	//glColor3f(this->kolor[0], this->kolor[1], this->kolor[2]);
	//glMaterialfv(GL_FRONT, GL_SPECULAR, MSpecular);
	float promien;
	GLUquadricObj *kulka;
	kulka=gluNewQuadric(); 
	gluQuadricNormals(kulka, GLU_SMOOTH); // z generowaniem normalnych
	
	switch (this->rodzaj)
	{
	case 0: promien=4;
			zniszczenia((int)this->pX, (int)this->pZ, promien, 1, gdzie);
		/*
			gdzie.zmien((int)this->pX, (int)this->pZ, -1);

			if ((gdzie.wysokosc(pX, pZ-1))>=gdzie.wysokosc(pX, pZ)) gdzie.zmien((int)this->pX, (int)this->pZ-1, -1);
			gdzie.zmien((int)this->pX, (int)this->pZ+1, -1);

			gdzie.zmien((int)this->pX-1, (int)this->pZ, -1);
			gdzie.zmien((int)this->pX+1, (int)this->pZ-1, -1);

			gdzie.zmien((int)this->pX+1, (int)this->pZ-1, -3);
			gdzie.zmien((int)this->pX-1, (int)this->pZ-1, -3);
			gdzie.zmien((int)this->pX+1, (int)this->pZ+1, -3);
			gdzie.zmien((int)this->pX-1, (int)this->pZ+1, -3);			
		  */
			// i odejmujemy od ewentualnego trafionego czolgu moc this->moc[rodzaj];
			break;
	case 1: promien=6;
			zniszczenia((int)this->pX, (int)this->pZ, promien, 2, gdzie);
			/*MAmbient[0]=0;
			MDiffuse[0]=0;
			gdzie.zmien((int)this->pX, (int)this->pZ, -5);
			//punkty[(int)pocisk.pZ][(int)pocisk.pX]-=5;
			gdzie.zmien((int)this->pX, (int)this->pZ-1, -3);
			//punkty[(int)pocisk.pZ-1][(int)pocisk.pX]-=3;
			gdzie.zmien((int)this->pX, (int)this->pZ+1, -3);
			//punkty[(int)pocisk.pZ+1][(int)pocisk.pX]-=3;
			gdzie.zmien((int)this->pX-1, (int)this->pZ, -3);
			//punkty[(int)pocisk.pZ][(int)pocisk.pX-1]-=3;
			gdzie.zmien((int)this->pX+1, (int)this->pZ-1, -3);
			//punkty[(int)pocisk.pZ-1][(int)pocisk.pX+1]-=3;

			gdzie.zmien((int)this->pX+1, (int)this->pZ-1, -3);
			//punkty[(int)pocisk.pZ-1][(int)pocisk.pX+1]-=3;
			gdzie.zmien((int)this->pX-1, (int)this->pZ-1, -3);
			//punkty[(int)pocisk.pZ-1][(int)pocisk.pX-1]-=3;
			gdzie.zmien((int)this->pX+1, (int)this->pZ+1, -3);
			//punkty[(int)pocisk.pZ+1][(int)pocisk.pX+1]-=3;
			gdzie.zmien((int)this->pX-1, (int)this->pZ+1, -3);
			//punkty[(int)pocisk.pZ+1][(int)pocisk.pX-1]-=3;			*/
			// i odejmujemy od ewentualnego trafionego czolgu moc this->moc[rodzaj];
			break;
	case 2: promien=8;
			zniszczenia((int)this->pX, (int)this->pZ, promien, 4, gdzie);
			/*MAmbient[1]=0;
			MDiffuse[1]=0;
			gdzie.zmien((int)this->pX, (int)this->pZ, -5);
			//punkty[(int)pocisk.pZ][(int)pocisk.pX]-=5;
			gdzie.zmien((int)this->pX, (int)this->pZ-1, -3);
			//punkty[(int)pocisk.pZ-1][(int)pocisk.pX]-=3;
			gdzie.zmien((int)this->pX, (int)this->pZ+1, -3);
			//punkty[(int)pocisk.pZ+1][(int)pocisk.pX]-=3;
			gdzie.zmien((int)this->pX-1, (int)this->pZ, -3);
			//punkty[(int)pocisk.pZ][(int)pocisk.pX-1]-=3;
			gdzie.zmien((int)this->pX+1, (int)this->pZ-1, -3);
			//punkty[(int)pocisk.pZ-1][(int)pocisk.pX+1]-=3;

			gdzie.zmien((int)this->pX+1, (int)this->pZ-1, -3);
			//punkty[(int)pocisk.pZ-1][(int)pocisk.pX+1]-=3;
			gdzie.zmien((int)this->pX-1, (int)this->pZ-1, -3);
			//punkty[(int)pocisk.pZ-1][(int)pocisk.pX-1]-=3;
			gdzie.zmien((int)this->pX+1, (int)this->pZ+1, -3);
			//punkty[(int)pocisk.pZ+1][(int)pocisk.pX+1]-=3;
			gdzie.zmien((int)this->pX-1, (int)this->pZ+1, -3);
			//punkty[(int)pocisk.pZ+1][(int)pocisk.pX-1]-=3;			*/
			// i odejmujemy od ewentualnego trafionego czolgu moc this->moc[rodzaj];
			break;
	case 3: promien=12;
			zniszczenia((int)this->pX, (int)this->pZ, promien, 7, gdzie);
			/*MAmbient[2]=0;
			MDiffuse[2]=0;
			gdzie.zmien((int)this->pX, (int)this->pZ, -5);
			//punkty[(int)pocisk.pZ][(int)pocisk.pX]-=5;
			gdzie.zmien((int)this->pX, (int)this->pZ-1, -3);
			//punkty[(int)pocisk.pZ-1][(int)pocisk.pX]-=3;
			gdzie.zmien((int)this->pX, (int)this->pZ+1, -3);
			//punkty[(int)pocisk.pZ+1][(int)pocisk.pX]-=3;
			gdzie.zmien((int)this->pX-1, (int)this->pZ, -3);
			//punkty[(int)pocisk.pZ][(int)pocisk.pX-1]-=3;
			gdzie.zmien((int)this->pX+1, (int)this->pZ-1, -3);
			//punkty[(int)pocisk.pZ-1][(int)pocisk.pX+1]-=3;

			gdzie.zmien((int)this->pX+1, (int)this->pZ-1, -3);
			//punkty[(int)pocisk.pZ-1][(int)pocisk.pX+1]-=3;
			gdzie.zmien((int)this->pX-1, (int)this->pZ-1, -3);
			//punkty[(int)pocisk.pZ-1][(int)pocisk.pX-1]-=3;
			gdzie.zmien((int)this->pX+1, (int)this->pZ+1, -3);
			//punkty[(int)pocisk.pZ+1][(int)pocisk.pX+1]-=3;
			gdzie.zmien((int)this->pX-1, (int)this->pZ+1, -3);
			//punkty[(int)pocisk.pZ+1][(int)pocisk.pX-1]-=3;			*/
			// i odejmujemy od ewentualnego trafionego czolgu moc this->moc[rodzaj];
			break;	 
	default: break;
	};
	glMaterialfv(GL_FRONT, GL_AMBIENT, MAmbient);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, MDiffuse);
		gluSphere(kulka,promien,10,10);//narysowanie kuli
		glTranslatef( -(int)this->pX, -tmpWys, -(int)this->pZ);
	return 1;


}

int cPocisk::sprawdz(float x, float y, float z, cTeren & gdzie)
{
	this->rysuj(x, y, z);
	if (((this->pY+y)-(gdzie.wysokosc((int)this->pX, (int)this->pZ)))<0.5)
	{ 
		//this->animacja=0;
		//this->strzelil=0;
		this->wybuch(gdzie);
		return 2; // bylo bum
		//MessageBox(hWnd, "Bum !", "Info", MB_OK|MB_ICONSTOP);
	};
	if (this->pX<0||this->pX>99||this->pZ<0||this->pZ>99) return 0;
	return 1;

}

int cPocisk::zniszczenia(int x, int z, int promien, int sila, cTeren &gdzie)
{
	gdzie.zmien(x,z,-sila);
	for (int q=z-promien; q<=z ;q++)
	{
	for (int v=x-promien;v<=x;v++)
	{
		if (( ( (v-x)*(v-x) )+ ( (q-z)*(q-z) ) )<=(promien*promien))
		{
			if (!((q==z)&&(v==x)))
			{
			if (((x+(x-v))<100)&&((x+(x-v))>=0)&&((z-(z-q))<100)&&((z-(z-q))>=0))
			if (((q!=z)&&(gdzie.wysokosc(x+(x-v), z-(z-q))))>=gdzie.wysokosc(x, z)) 
				//if (q!=z)
				gdzie.zmien(x+(x-v), z-(z-q), -sila);
			if (((x+(x-v))<100)&&((x+(x-v))>=0)&&((z+(z-q))<100)&&((z+(z-q))>=0))
			if (((v!=x)&&(gdzie.wysokosc(x+(x-v), z+(z-q))))>=gdzie.wysokosc(x, z)) 
				//if (v!=x)
				gdzie.zmien(x+(x-v), z+(z-q), -sila);
			if (((x-(x-v))<100)&&((x-(x-v))>=0)&&((z-(z-q))<100)&&((z-(z-q))>=0))
			if (((v!=x)&&(gdzie.wysokosc(x-(x-v), z-(z-q))))>=gdzie.wysokosc(x, z)) 
				//if (v!=x)
				gdzie.zmien(x-(x-v), z-(z-q), -sila);
			if (((x-(x-v))<100)&&((x-(x-v))>=0)&&((z+(z-q))<100)&&((z+(z-q))>=0))
			if (((q!=z)&&(gdzie.wysokosc(x-(x-v), z+(z-q))))>=gdzie.wysokosc(x, z)) 
				//if (q!=z)
				gdzie.zmien(x-(x-v), z+(z-q), -sila);
			};
		};
	};
	};
	return 1;
}
