// cTeren.cpp: implementation of the cTeren class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ble.h"
#include "cTeren.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>

#define PI 3.141


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

cTeren::cTeren()
{
	this->maxWys=10;
	this->maxXkw=25;
	this->maxZkw=25;
	this->ileKwX=4;
	this->ileKwZ=4;
//	this->generuj();
}

cTeren::~cTeren()
{

}

int cTeren::generuj()
{
    srand( (unsigned)time( NULL ) ); // ustawiamy generator liczb losowych
	int tmp1, tmp2;
	for (int z=0;  z<this->ileKwZ; z++) 
	{
		if (z==0) tmp1=rand()%360;
		tmp2=rand()%360;
		for (int x=0;  x<this->ileKwX; x++) 
		{
			if (z>0) tmp1=this->zstrt[z-1][x]+this->zszer[z-1][x];
			this->zstrt[z][x]=tmp1;
			this->zszer[z][x]=tmp2;
		};
	};


	for (int x=0;  x<this->ileKwX; x++) 
	{
		if (x==0) tmp1=rand()%360; 
		tmp2=rand()%360;
		for (int z=0;  z<this->ileKwZ; z++) 
		{
			if (x>0) tmp1=this->xstrt[z][x-1]+this->xszer[z][x-1];
			this->xstrt[z][x]=tmp1;
			this->xszer[z][x]=tmp2;
		};
   	};
	
	float AktAmpl;
	float xdelta;
	float zdelta;
	for (z=0; z<(ileKwZ*maxZkw); z++)
	{
		for (int x=0; x<(ileKwX*maxXkw); x++)	
		{
			xdelta=(float)this->xszer[(int)(z/this->maxZkw)][(int)(x/this->maxXkw)]/this->maxXkw;
			zdelta=(float)this->zszer[(int)(z/this->maxZkw)][(int)(x/this->maxXkw)]/this->maxZkw;
			AktAmpl=(float)this->maxWys;
			this->punkty[z][x]=(float)(AktAmpl*sin((xstrt[(int)(z/this->maxZkw)][(int)(x/this->maxXkw)]+(x-((int)(x/this->maxXkw)*this->maxXkw))*xdelta)*PI/180)*sin((this->zstrt[(int)(z/this->maxZkw)][(int)(x/this->maxXkw)]+(z-((int)(z/this->maxZkw)*this->maxZkw))*zdelta)*PI/180));
		};
	};   
 return 1;
}

int cTeren::rysuj()
{

		glColor3f(0.2, 0, 0);
	glBegin(GL_TRIANGLES); 
	for (int z=0; z<(this->ileKwZ*this->maxZkw-1); z++)
	{
		
		glVertex3f(0, -this->maxWys, z );
		glVertex3f(0, this->punkty[z][0], z);
		glVertex3f(0, -this->maxWys, (z+1));

		glVertex3f(0, this->punkty[z+1][0], (z+1));
		glVertex3f(0, this->punkty[z][0], z);
		glVertex3f(0, -this->maxWys, (z+1));

		glVertex3f(this->maxXkw*this->ileKwX-1, -this->maxWys, z );
		glVertex3f(this->maxXkw*this->ileKwX-1, this->punkty[z][this->maxXkw*this->ileKwX-1], z);
		glVertex3f(this->maxXkw*this->ileKwX-1, -this->maxWys, (z+1));

		glVertex3f(this->maxXkw*this->ileKwX-1, this->punkty[z+1][this->maxXkw*this->ileKwX-1], (z+1));
		glVertex3f(this->maxXkw*this->ileKwX-1, this->punkty[z][this->maxXkw*this->ileKwX-1], z);
		glVertex3f(this->maxXkw*this->ileKwX-1, -this->maxWys, (z+1));

	};


	for (int x=0; x<(this->ileKwZ*this->maxZkw-1); x++)
	{
		glVertex3f(x, -this->maxWys, 0 );
		glVertex3f(x, this->punkty[0][x], 0);
		glVertex3f(x+1, -this->maxWys, 0);

		glVertex3f(x, this->punkty[0][x], 0);
		glVertex3f(x+1, this->punkty[0][x+1], 0);
		glVertex3f(x+1, -this->maxWys, 0);


		glVertex3f(x, -this->maxWys, (this->maxZkw*this->ileKwZ-1));
		glVertex3f(x, this->punkty[this->maxZkw*this->ileKwZ-1][x], (this->maxZkw*this->ileKwZ-1));
		glVertex3f(x+1, -this->maxWys, (this->maxZkw*this->ileKwZ-1));

		glVertex3f(x, this->punkty[this->maxZkw*this->ileKwZ-1][x], (this->maxZkw*this->ileKwZ-1));
		glVertex3f(x+1, this->punkty[this->maxZkw*this->ileKwZ-1][x+1], (this->maxZkw*this->ileKwZ-1));
		glVertex3f(x+1, -this->maxWys, (this->maxZkw*this->ileKwZ-1));
  };


	//GLfloat MAmbient[]= { 0, 0.2, 0, 1.0f }; 
    //GLfloat MDiffuse[]= { 0, 0.5, 0, 1.0f }; 
	//glMaterialfv(GL_FRONT, GL_AMBIENT, MAmbient);
	//glMaterialfv(GL_FRONT, GL_DIFFUSE, MDiffuse);

	for (int y=0; y<(this->ileKwZ*this->maxZkw-1); y++)
	{
		for (int x=0; x<(this->ileKwX*this->maxXkw-1); x++)	
		{


		this->UstawKolory(this->punkty[y][x]);
		glVertex3f(x, this->punkty[y][x], y );
		
		this->UstawKolory(this->punkty[y][x+1]);
		glVertex3f((x+1), this->punkty[y][x+1], y);
		
		this->UstawKolory(this->punkty[y+1][x]);
		glVertex3f(x, this->punkty[y+1][x], (y+1));
		};
	};
	//glColor3f(255, 0, 0);
	for (y=1; y<(this->ileKwZ*this->maxZkw); y++)
	{
		for (int x=0; x<(this->ileKwX*this->maxXkw-1); x++)	
/*
	for (y=1; y<maxY; y++)
	{
		for (int x=0; x<(maxX-1); x++)	
*/
		{
		
		this->UstawKolory(this->punkty[y][x]);
		glVertex3f(x, this->punkty[y][x], y );
		
		this->UstawKolory(this->punkty[y][x+1]);
		glVertex3f((x+1), this->punkty[y][x+1], y);
		
		this->UstawKolory(this->punkty[y-1][x+1]);
		glVertex3f((x+1), this->punkty[y-1][x+1], (y-1));

		};
	};
	return 1;
}

void cTeren::UstawKolory(float wys)
{
	float r, g, b;
	r=(float)(wys+maxWys)/(2*maxWys+2)+(float)2/(2*maxWys+2);
	g=(float)(wys+maxWys)/(2*maxWys+2)+(float)2/(2*maxWys+2);
	b=(float)(wys+maxWys)/(2*maxWys+2)+(float)2/(2*maxWys+2);
	//if ((g<0.8)&&(g>0.3)) {g=0.7;}
	if (g<0.8) {g=0.5;}
	//if (b<0.3) {b=0.5;}
	glColor3f(r, g, b);
}

float cTeren::wysokosc(int x, int z)
{
	return this->punkty[z][x];
}

int cTeren::ustaw(int x, int z, float wart)
{
	this->punkty[z][x]=wart;
	return 1;
}

int cTeren::zmien(int x, int z, float del)
{
	this->punkty[z][x]+=del;
	return 1;
}
